#include <stdio.h>
#include <string.h>
#define SSIZE 20
#define INPUTSIZE 10

int min(int,int);
int main(void)
{
	char *s0;
	char *s1;
	char s2[SSIZE];
	char s3[SSIZE] = {'a','r','r','a','y','\0'};
	char s4[SSIZE];
	int i=0;
	int ch;
	
	
	printf("%p\n","ciao"); /*ciao e' una stringa (puntatore a una sequenza di caratteri terminata da \0) che viene piazzata nella memoria gia' inizializzata del programma*/
	
	/*Gli array sono puntatori, se sono terminati da un carattere nullo sono quindi anche stringhe*/
	s0 = s3;
	printf("%p - %p || %s - %s \n",s0,s3,s0,s3);
	
	/*Possiamo prendere il puntatore al 3 carattere*/
	s0 = &s3[2];
	printf("%p - %p || %s - %s \n",s0,s3,s0,s3);
	/*Che e' la stessa cosa di */
	printf("%d\n",&s3[2] == s3+2);

	s0 = "prova";
	s1 = "ciaociao";
	printf("%p - %p\n",s0,s1); /* L'indirizzo del prova/ciao alla riga sopra e' ora in s0/s1*/
	
	/* Il mio compilatore le mette una di seguito all'altra,*/
	printf("%ld\n",s1-s0);/*Stampa 6 perche' len(prova)=5 ma viene aggiunto il carattere nullo al termine.*/
	
	/* Prendiamo due stringhe da input usando solo la funzione getchar notare che getchar prende anche gli a capo come caratteri */
	/*Usare Ctrl-D per mandare EOF su stdin */
	while((ch = getchar()) != EOF && i < SSIZE-INPUTSIZE-1){
    	s2[i] = ch;
    	/* *(s2+i) = ch */ /* alternativa */
    	i++;
    }
    s2[SSIZE-INPUTSIZE-1]=0;
	printf("\n");
	
	/* s2 e' ora una stringa perche' s2[SSIZE-INPUTSIZE-1] e' il carattere nullo*/
	printf("Hai inserito : %s\n",s2);
	
	/*Concateniamo s2 ed s3 nello spazio che abbiamo*/
	strncat(s2,s3, min(SSIZE-strlen(s2)-1,strlen(s3)));
	printf("%s \n",s2);
	
	/*Compariamo s2 ed s3*/
	printf("Risultato comparazione di %s ed %s: %d \n",s2,s3,strcmp(s2,s3));
	
	printf("%lu\n",strlen(s4)); /* Questo valore non si puo' predire, infatti le variabili locali non vengono inizializzate e quindi il loro contenuto puo' essere zero o meno, posso anche ottenere un segmentation fault perche' se non trova nessuno zero che la fermi la funzione strlen puo' andare a leggere una porzione di memoria che non e' concesso leggere*/
	
	return 0;
}

int min(int x,int y){
	if(x<y)
		return x;
	else
		return y;
}
